using FluentValidation;
using CMSMicroservice.Protobuf.Protos.Package;
namespace CMSMicroservice.Protobuf.Validator.Package;

public class GetAllPackageByFilterRequestValidator : AbstractValidator<GetAllPackageByFilterRequest>
{
    public GetAllPackageByFilterRequestValidator()
    {
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<GetAllPackageByFilterRequest>.CreateWithOptions((GetAllPackageByFilterRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
